diff -urN ../VisualBoyAdvance-1.7.2/src/Cheats.cpp ./src/Cheats.cpp
--- ../VisualBoyAdvance-1.7.2/src/Cheats.cpp	2004-05-13 23:38:33 +0900
+++ ./src/Cheats.cpp	2006-06-25 05:21:47 +0900
@@ -712,11 +1542,46 @@
   cheatsVerifyCheatCode(code, desc);
 }
 
-void cheatsDecryptGSACode(u32& address, u32& value, bool v3) 
+u16 cheatsGSAGetDeadface(bool v3)
+{
+  for(int i = cheatsNumber-1; i >= 0; i--)
+    if ((cheatsList[i].address == 0xDEADFACE) && (cheatsList[i].code == (v3 ? 257 : 256)))
+      return cheatsList[i].value & 0xFFFF;
+	return 0;
+}
+
+void cheatsGSAChangeEncryption(u16 value, bool v3) {
+	int i;
+	u8 *deadtable1, *deadtable2;
+
+	if (v3) {
+		deadtable1 = (u8*)(&v3_deadtable1);
+		deadtable2 = (u8*)(&v3_deadtable2);
+	        for (i = 0; i < 4; i++)
+		  seeds_v3[i] = seed_gen(((value & 0xFF00) >> 8), (value & 0xFF) + i, deadtable1, deadtable2);
+	}
+	else {
+		deadtable1 = (u8*)(&v1_deadtable1);
+		deadtable2 = (u8*)(&v1_deadtable2);
+		for (i = 0; i < 4; i++){
+		  seeds_v1[i] = seed_gen(((value & 0xFF00) >> 8), (value & 0xFF) + i, deadtable1, deadtable2);
+		}
+	}
+}
+
+u32 seed_gen(u8 upper, u8 seed, u8 *deadtable1, u8 *deadtable2) {
+	int i;
+	u32 newseed = 0;
+
+	for (i = 0; i < 4; i++)
+		newseed = ((newseed << 8) | ((deadtable1[(i + upper) & 0xFF] + deadtable2[seed]) & 0xFF));
+		   
+	return newseed;
+}
+
+void cheatsDecryptGSACode(u32& address, u32& value, bool v3)
 {
   u32 rollingseed = 0xC6EF3720;
-  u32 seeds_v1[] =  { 0x09F4FBBD, 0x9681884A, 0x352027E9, 0xF3DEE5A7 }; 
-  u32 seeds_v3[] = { 0x7AA9648F, 0x7FAE6994, 0xC0EFAAD5, 0x42712C57 };
   u32 *seeds = v3 ? seeds_v3 : seeds_v1;
   
   int bitsleft = 32;
@@ -758,7 +1623,7 @@
   buffer[8] = 0;
   u32 value;
   sscanf(buffer, "%x", &value);
-
+  cheatsGSAChangeEncryption(cheatsGSAGetDeadface (v3), v3);
   cheatsDecryptGSACode(address, value, v3);
 
   if(value == 0x1DC0DE) {
@@ -773,17 +1638,26 @@
       systemMessage(MSG_GBA_CODE_WARNING, N_("Warning: cheats are for game %s. Current game is %s.\nCodes may not work correctly."),
                     buffer, buffer2);
     }
-    cheatsAdd(code, desc, address & 0x0FFFFFFF, value, v3 ? 257 : 256, 
+    cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value, v3 ? 257 : 256, 
               UNKNOWN_CODE);
     return;
   }
   if(isMultilineWithData(cheatsNumber-1)) {
-    cheatsAdd(code, desc, address, value, v3 ? 257 : 256, UNKNOWN_CODE);
+    cheatsAdd(code, desc, address, address, value, v3 ? 257 : 256, UNKNOWN_CODE);
     return;
   }
   if(v3) {
-    int type = (address >> 25) & 127;
+    int type = ((address >> 25) & 127) | ((address >> 17) & 0x80);
     u32 addr = (address & 0x00F00000) << 4 | (address & 0x0003FFFF);
+    u16 mcode = (address>>24 & 0xFF);
+
+    if ((mcode & 0xFE) == 0xC4)
+    {
+      cheatsAdd(code, desc, address, (address & 0x1FFFFFF) | (0x08000000),
+        value, 257, MASTER_CODE);
+      mastercode = (address & 0x1FFFFFF) | (0x08000000);
+    }
+    else
     switch(type) {
     case 0x00:
       if(address == 0) {
@@ -791,83 +1665,278 @@
         addr = (value & 0x00F00000) << 4 | (value & 0x0003FFFF);
         switch(type) {
         case 0x04:
-          cheatsAdd(code, desc, 0, value & 0x00FFFFFF, 257, GSA_SLOWDOWN);
+          cheatsAdd(code, desc, address, 0, value & 0x00FFFFFF, 257, GSA_SLOWDOWN);
           break;
         case 0x08:
-          cheatsAdd(code, desc, 0, addr, 257, GSA_8_BIT_GS_WRITE2);
+          cheatsAdd(code, desc, address, 0, addr, 257, GSA_8_BIT_GS_WRITE2);
           break;
         case 0x09:
-          cheatsAdd(code, desc, 0, addr, 257, GSA_16_BIT_GS_WRITE2);
+          cheatsAdd(code, desc, address, 0, addr, 257, GSA_16_BIT_GS_WRITE2);
           break;
         case 0x0a:
-          cheatsAdd(code, desc, 0, addr, 257, GSA_32_BIT_GS_WRITE2);
+          cheatsAdd(code, desc, address, 0, addr, 257, GSA_32_BIT_GS_WRITE2);
           break;
         case 0x0c:
+          cheatsAdd(code, desc, address, 0, value & 0x00FFFFFF, 257, GSA_16_BIT_ROM_PATCH2C);
+          break;
         case 0x0d:
+          cheatsAdd(code, desc, address, 0, value & 0x00FFFFFF, 257, GSA_16_BIT_ROM_PATCH2D);
+          break;
         case 0x0e:
+          cheatsAdd(code, desc, address, 0, value & 0x00FFFFFF, 257, GSA_16_BIT_ROM_PATCH2E);
+          break;
         case 0x0f:
-          cheatsAdd(code, desc, 0, value & 0x00FFFFFF, 257, GSA_16_BIT_ROM_PATCH2);
+          cheatsAdd(code, desc, address, 0, value & 0x00FFFFFF, 257, GSA_16_BIT_ROM_PATCH2F);
+          break;
+        case 0x20:
+          cheatsAdd(code, desc, address, 0, addr, 257, GSA_CODES_ON);
           break;
         case 0x40:
-          cheatsAdd(code, desc, 0, addr, 257, GSA_8_BIT_SLIDE);
+          cheatsAdd(code, desc, address, 0, addr, 257, GSA_8_BIT_SLIDE);
           break;
         case 0x41:
-          cheatsAdd(code, desc, 0, addr, 257, GSA_16_BIT_SLIDE);
+          cheatsAdd(code, desc, address, 0, addr, 257, GSA_16_BIT_SLIDE);
           break;
         case 0x42:
-          cheatsAdd(code, desc, 0, addr, 257, GSA_32_BIT_SLIDE);
+          cheatsAdd(code, desc, address, 0, addr, 257, GSA_32_BIT_SLIDE);
           break;
         default:
-          cheatsAdd(code, desc, address, value, 257, UNKNOWN_CODE);
+          cheatsAdd(code, desc, address, address, value, 257, UNKNOWN_CODE);
           break;
         }
       } else
-        cheatsAdd(code, desc, addr, value, 257, GSA_8_BIT_FILL);
+        cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_FILL);
       break;
     case 0x01:
-      cheatsAdd(code, desc, addr, value, 257, GSA_16_BIT_FILL);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_FILL);
       break;
     case 0x02:
-      cheatsAdd(code, desc, addr, value, 257, INT_32_BIT_WRITE);
+      cheatsAdd(code, desc, address, addr, value, 257, INT_32_BIT_WRITE);
       break;
     case 0x04:
-      cheatsAdd(code, desc, addr, value, 257, GSA_8_BIT_IF_TRUE);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_TRUE);
       break;
     case 0x05:
-      cheatsAdd(code, desc, addr, value, 257, CBA_IF_TRUE);
+      cheatsAdd(code, desc, address, addr, value, 257, CBA_IF_TRUE);
       break;
     case 0x06:
-      cheatsAdd(code, desc, addr, value, 257, GSA_32_BIT_IF_TRUE);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_TRUE);
+      break;
+    case 0x07:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_ALWAYS);
       break;
     case 0x08:
-      cheatsAdd(code, desc, addr, value, 257, GSA_8_BIT_IF_FALSE);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_FALSE);
       break;
     case 0x09:
-      cheatsAdd(code, desc, addr, value, 257, CBA_IF_FALSE);
+      cheatsAdd(code, desc, address, addr, value, 257, CBA_IF_FALSE);
       break;
     case 0x0a:
-      cheatsAdd(code, desc, addr, value, 257, GSA_32_BIT_IF_FALSE);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_FALSE);
+      break;
+    case 0xc:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_LOWER_S);
+      break;
+    case 0xd:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_LOWER_S);
+      break;
+    case 0xe:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_LOWER_S);
+      break;
+    case 0x10:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_HIGHER_S);
+      break;
+    case 0x11:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_HIGHER_S);
+      break;
+    case 0x12:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_HIGHER_S);
+      break;
+    case 0x14:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_LOWER_U);
+      break;
+    case 0x15:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_LOWER_U);
+      break;
+    case 0x16:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_LOWER_U);
+      break;
+    case 0x18:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_HIGHER_U);
+      break;
+    case 0x19:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_HIGHER_U);
+      break;
+    case 0x1A:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_HIGHER_U);
+      break;
+    case 0x1C:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_AND);
+      break;
+    case 0x1D:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_AND);
+      break;
+    case 0x1E:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_AND);
+      break;
+    case 0x20:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_POINTER);
+      break;
+    case 0x21:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_POINTER);
+      break;
+    case 0x22:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_POINTER);
       break;
     case 0x24:
-      cheatsAdd(code, desc, addr, value, 257, GSA_8_BIT_IF_TRUE2);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_TRUE2);
       break;
     case 0x25:
-      cheatsAdd(code, desc, addr, value, 257, GSA_16_BIT_IF_TRUE2);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_TRUE2);
       break;
     case 0x26:
-      cheatsAdd(code, desc, addr, value, 257, GSA_32_BIT_IF_TRUE2);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_TRUE2);
+      break;
+    case 0x27:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_ALWAYS2);
       break;
     case 0x28:
-      cheatsAdd(code, desc, addr, value, 257, GSA_8_BIT_IF_FALSE2);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_FALSE2);
       break;
     case 0x29:
-      cheatsAdd(code, desc, addr, value, 257, GSA_16_BIT_IF_FALSE2);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_FALSE2);
       break;
     case 0x2a:
-      cheatsAdd(code, desc, addr, value, 257, GSA_32_BIT_IF_FALSE2);
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_FALSE2);
+      break;
+    case 0x2c:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_LOWER_S2);
+      break;
+    case 0x2d:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_LOWER_S2);
+      break;
+    case 0x2e:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_LOWER_S2);
+      break;
+    case 0x30:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_HIGHER_S2);
+      break;
+    case 0x31:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_HIGHER_S2);
+      break;
+    case 0x32:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_HIGHER_S2);
+      break;
+    case 0x34:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_LOWER_U2);
+      break;
+    case 0x35:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_LOWER_U2);
+      break;
+    case 0x36:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_LOWER_U2);
+      break;
+    case 0x38:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_HIGHER_U2);
+      break;
+    case 0x39:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_HIGHER_U2);
+      break;
+    case 0x3A:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_HIGHER_U2);
+      break;
+    case 0x3C:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_AND2);
+      break;
+    case 0x3D:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_AND2);
+      break;
+    case 0x3E:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_AND2);
+      break;
+    case 0x40:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_ADD);
+      break;
+    case 0x41:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_ADD);
+      break;
+    case 0x42:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_ADD);
+      break;
+    case 0x44:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_TRUE3);
+      break;
+    case 0x45:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_TRUE3);
+      break;
+    case 0x46:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_TRUE3);
+      break;
+	  case 0x47:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_ALWAYS3);
+      break;
+    case 0x48:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_FALSE3);
+      break;
+    case 0x49:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_FALSE3);
+      break;
+    case 0x4a:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_FALSE3);
+      break;
+    case 0x4c:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_LOWER_S3);
+      break;
+    case 0x4d:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_LOWER_S3);
+      break;
+    case 0x4e:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_LOWER_S3);
+      break;
+    case 0x50:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_HIGHER_S3);
+      break;
+    case 0x51:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_HIGHER_S3);
+      break;
+    case 0x52:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_HIGHER_S3);
+      break;
+    case 0x54:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_LOWER_U3);
+      break;
+    case 0x55:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_LOWER_U3);
+      break;
+    case 0x56:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_LOWER_U3);
+      break;
+    case 0x58:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_HIGHER_U3);
+      break;
+    case 0x59:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_HIGHER_U3);
+      break;
+    case 0x5a:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_HIGHER_U3);
+      break;
+    case 0x5c:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_8_BIT_IF_AND3);
+      break;
+    case 0x5d:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_IF_AND3);
+      break;
+    case 0x5e:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_IF_AND3);
+      break;
+    case 0x63:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_16_BIT_WRITE_IOREGS);
+      break;
+    case 0xE3:
+      cheatsAdd(code, desc, address, addr, value, 257, GSA_32_BIT_WRITE_IOREGS);
       break;
     default:
-      cheatsAdd(code, desc, address, value, 257, UNKNOWN_CODE);
+      cheatsAdd(code, desc, address, address, value, 257, UNKNOWN_CODE);
       break;
     }
   } else {
@@ -876,54 +1945,136 @@
     case 0:
     case 1:
     case 2:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 256, type);
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value, 256, type);
+      break;
+    case 3:
+	  switch ((address >> 0x10) & 0xFF){
+	  case 0x00:
+        cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value, 256, GSA_GROUP_WRITE);
+	    break;
+	  case 0x10:
+	    cheatsAdd(code, desc, address, value & 0x0FFFFFFF, address & 0xFF, 256, GSA_32_BIT_ADD );
+	    break;
+	  case 0x20:
+	    cheatsAdd(code, desc, address, value & 0x0FFFFFFF, (~(address & 0xFF)+1), 256, GSA_32_BIT_ADD );
+	    break;
+	  case 0x30:
+	    cheatsAdd(code, desc, address, value & 0x0FFFFFFF, address & 0xFFFF, 256, GSA_32_BIT_ADD );
+	    break;
+	  case 0x40:
+	    cheatsAdd(code, desc, address, value & 0x0FFFFFFF, (~(address & 0xFFFF)+1), 256, GSA_32_BIT_ADD );
+	    break;
+	  case 0x50:
+	    cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value, 256, GSA_32_BIT_ADD2);
+	    break;
+	  case 0x60:
+	    cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value, 256, GSA_32_BIT_SUB2);
+	    break;
+      default:
+        // unsupported code
+        cheatsAdd(code, desc, address, address, value, 256, 
+                  UNKNOWN_CODE);
+        break;
+      }
       break;
     case 6:
       address <<= 1;
-      type = (address >> 28) & 15;
-      if(type == 0x0c) {
-        cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 256, 
+      type = (value >> 24) & 0xFF;
+      if(type == 0x00) {
+        cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value & 0xFFFF, 256, 
                   GSA_16_BIT_ROM_PATCH);
         break;
       }
       // unsupported code
-      cheatsAdd(code, desc, address, value, 256, 
+      cheatsAdd(code, desc, address, address, value, 256, 
                 UNKNOWN_CODE);
       break;
     case 8:
       switch((address >> 20) & 15) {
       case 1:
-        cheatsAdd(code, desc, address & 0x0F0FFFFF, value, 256, 
+        cheatsAdd(code, desc, address, address & 0x0F0FFFFF, value, 256, 
                   GSA_8_BIT_GS_WRITE);
         break;
       case 2:
-        cheatsAdd(code, desc, address & 0x0F0FFFFF, value, 256, 
+        cheatsAdd(code, desc, address, address & 0x0F0FFFFF, value, 256, 
                   GSA_16_BIT_GS_WRITE);
         break;
-      case 3:
-        cheatsAdd(code, desc, address & 0x0F0FFFFF, value, 256, 
+      case 4:
+		// This code is buggy : the value is always set to 0 !
+        cheatsAdd(code, desc, address, address & 0x0F0FFFFF, 0, 256, 
                   GSA_32_BIT_GS_WRITE);
+        break;
       case 15:
-        cheatsAdd(code, desc, 0, value & 0xFF00, 256, GSA_SLOWDOWN);
+        cheatsAdd(code, desc, address, 0, value & 0xFFFF, 256, GSA_SLOWDOWN);
         break;
       default:
         // unsupported code
-        cheatsAdd(code, desc, address, value, 256, 
+        cheatsAdd(code, desc, address, address, value, 256, 
                   UNKNOWN_CODE);
         break;
       }
       break;
     case 0x0d:
       if(address != 0xDEADFACE) {
-        cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 256, 
+        switch((value >> 20) & 0xF) {
+        case 0:
+        cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value & 0xFFFF, 256, 
                   CBA_IF_TRUE);
+          break;
+        case 1:
+        cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value & 0xFFFF, 256, 
+                  CBA_IF_FALSE);
+          break;
+        case 2:
+        cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value & 0xFFFF, 256, 
+                  GSA_16_BIT_IF_LOWER_OR_EQ_U);
+          break;
+        case 3:
+        cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value & 0xFFFF, 256, 
+                  GSA_16_BIT_IF_HIGHER_OR_EQ_U);
+          break;
+        default:
+        // unsupported code
+        cheatsAdd(code, desc, address, address, value, 256, 
+                  UNKNOWN_CODE);
+          break;
+		}
       } else
-        cheatsAdd(code, desc, address, value, 256, 
+        cheatsAdd(code, desc, address, address, value, 256, 
                   UNKNOWN_CODE);
       break;
-    default:
+    case 0x0e:
+      switch((value >> 28) & 0xF) {
+      case 0:
+      cheatsAdd(code, desc, address, value & 0x0FFFFFFF, address & 0xFFFF, 256, 
+                GSA_16_BIT_MIF_TRUE);
+        break;
+      case 1:
+      cheatsAdd(code, desc, address, value & 0x0FFFFFFF, address & 0xFFFF, 256, 
+                GSA_16_BIT_MIF_FALSE);
+        break;
+      case 2:
+      cheatsAdd(code, desc, address, value & 0x0FFFFFFF, address & 0xFFFF, 256, 
+                GSA_16_BIT_MIF_LOWER_OR_EQ_U);
+        break;
+      case 3:
+      cheatsAdd(code, desc, address, value & 0x0FFFFFFF, address & 0xFFFF, 256, 
+                GSA_16_BIT_MIF_HIGHER_OR_EQ_U);
+        break;
+      default:
+        // unsupported code
+        cheatsAdd(code, desc, address, address, value, 256, 
+                  UNKNOWN_CODE);
+        break;
+      }
+      break;
+      case 0x0f:
+        cheatsAdd(code, desc, address, (address & 0xFFFFFFF), value, 256, MASTER_CODE);
+        mastercode = (address & 0xFFFFFFF);
+        break;
+      default:
       // unsupported code
-      cheatsAdd(code, desc, address, value, 256, 
+      cheatsAdd(code, desc, address, address, value, 256, 
                 UNKNOWN_CODE);
       break;
     }
@@ -1359,7 +2510,7 @@
     u32 seed[8];
     cheatsCBAParseSeedCode(address, value, seed);
     cheatsCBAChangeEncryption(seed);
-    cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, UNKNOWN_CODE);
+    cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value, 512, UNKNOWN_CODE);
   } else {
     if(cheatsCBAShouldDecrypt())
       cheatsCBADecrypt(array);
@@ -1369,8 +2520,10 @@
     
     int type = (address >> 28) & 15;
 
-    if(isMultilineWithData(cheatsNumber-1)) {
-      cheatsAdd(code, desc, address, value, 512, UNKNOWN_CODE);
+    if(isMultilineWithData(cheatsNumber-1) || (super>0)) {
+      cheatsAdd(code, desc, address, address, value, 512, UNKNOWN_CODE);
+	  if (super>0)
+		  super-= 1;
       return;
     }
     
@@ -1384,61 +2537,71 @@
           systemMessage(MSG_CBA_CODE_WARNING,
                         N_("Warning: Codes seem to be for a different game.\nCodes may not work correctly."));
         }
-        cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
+        cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value, 512, 
                   UNKNOWN_CODE);
       }
       break;
+    case 0x01:
+      cheatsAdd(code, desc, address, (address & 0x1FFFFFF) | 0x08000000, value, 512, MASTER_CODE);
+      mastercode = (address & 0x1FFFFFF) | 0x08000000;
+      break;
     case 0x02:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFE, value, 512, 
                 CBA_OR);
       break;
     case 0x03:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value, 512, 
                 INT_8_BIT_WRITE);
       break;
     case 0x04:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFE, value, 512, 
                 CBA_SLIDE_CODE);
       break;
     case 0x05:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512,
-                CBA_SUPER);
+		cheatsAdd(code, desc, address, address & 0x0FFFFFFE, value, 512,
+                  CBA_SUPER);
+		super = getCodeLength(cheatsNumber-1);
       break;
     case 0x06:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFE, value, 512, 
                 CBA_AND);
       break;
     case 0x07:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFE, value, 512, 
                 CBA_IF_TRUE);
       break;
     case 0x08:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFE, value, 512, 
                 INT_16_BIT_WRITE);
       break;
     case 0x0a:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFE, value, 512, 
                 CBA_IF_FALSE);
       break;
     case 0x0b:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
-                CBA_LT);
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFE, value, 512, 
+                CBA_GT);
       break;
     case 0x0c:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
-                CBA_GT);
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFE, value, 512, 
+                CBA_LT);
       break;
     case 0x0d:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512, 
+		if ((address & 0xF0)<0x30)
+      cheatsAdd(code, desc, address, address & 0xF0, value, 512, 
                 CBA_IF_KEYS_PRESSED);
       break;
     case 0x0e:
-      cheatsAdd(code, desc, address & 0x0FFFFFFF, value, 512,
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFF, value & 0x8000 ? value | 0xFFFF0000 : value, 512,
                 CBA_ADD);
       break;
+    case 0x0f:
+      cheatsAdd(code, desc, address, address & 0x0FFFFFFE, value, 512,
+                GSA_16_BIT_IF_AND);
+      break;
     default:
       // unsupported code
-      cheatsAdd(code, desc, address & 0xFFFFFFFF, value, 512, 
+      cheatsAdd(code, desc, address, address & 0xFFFFFFFF, value, 512, 
                 UNKNOWN_CODE);
       break;
     }
@@ -1452,17 +2615,33 @@
   utilGzWrite(file, cheatsList, sizeof(cheatsList));
 }
 
-void cheatsReadGame(gzFile file)
+void cheatsReadGame(gzFile file, int version)
 {
   cheatsNumber = 0;
   
   cheatsNumber = utilReadInt(file);
 
-  utilGzRead(file, cheatsList, sizeof(cheatsList));
+  if (version > 8)
+    utilGzRead(file, cheatsList, sizeof(cheatsList));
+
 
   bool firstCodeBreaker = true;
   
   for(int i = 0; i < cheatsNumber; i++) {
+    if (version <9)
+    {
+        cheatsList[i].code = utilReadInt(file);
+        cheatsList[i].size = utilReadInt(file);
+        cheatsList[i].status = utilReadInt(file);
+        cheatsList[i].enabled = utilReadInt(file) ? true : false;
+        utilGzRead(file, &cheatsList[i].address, sizeof(u32));
+        cheatsList[i].rawaddress = cheatsList[i].address;
+        utilGzRead(file, &cheatsList[i].value, sizeof(u32));
+        utilGzRead(file, &cheatsList[i].oldValue, sizeof(u32));
+        utilGzRead(file, &cheatsList[i].codestring, 20*sizeof(char));
+        utilGzRead(file, &cheatsList[i].desc, 32*sizeof(char));
+    }
+
     cheatsList[i].status = 0;
     if(!cheatsList[i].codestring[0]) {
       switch(cheatsList[i].size) {
@@ -1515,7 +2694,7 @@
     return;
   int version = 1;
   fwrite(&version, 1, sizeof(version), f);
-  int type = 0;
+  int type = 1;
   fwrite(&type, 1, sizeof(type), f);
   fwrite(&cheatsNumber, 1, sizeof(cheatsNumber), f);
   fwrite(cheatsList, 1, sizeof(cheatsList), f);
@@ -1524,7 +2703,6 @@
 
 bool cheatsLoadCheatList(const char *file)
 {
-  cheatsNumber = 0;
 
   int count = 0;
 
@@ -1553,7 +2731,8 @@
     return false;
   }
 
-  if(type != 0) {
+
+  if((type != 0) && (type != 1)) {
     systemMessage(MSG_UNSUPPORTED_CHEAT_LIST_TYPE,
                   N_("Unsupported cheat list type %d"), type);
     fclose(f);
@@ -1564,10 +2743,31 @@
     fclose(f);
     return false;
   }
-  
-  if(fread(cheatsList, 1, sizeof(cheatsList), f) != sizeof(cheatsList)) {
-    fclose(f);
-    return false;
+  if (type == 1)
+  {
+    if(fread(cheatsList, 1, sizeof(cheatsList), f) != sizeof(cheatsList)) {
+      fclose(f);
+      return false;
+    }
+  }
+  else if (type == 0)
+  {
+    for(int i = 0; i < count; i++) {
+      fread(&cheatsList[i].code, 1, sizeof(int),f);
+      fread(&cheatsList[i].size, 1, sizeof(int),f);
+      fread(&cheatsList[i].status, 1, sizeof(int),f);
+      fread(&cheatsList[i].enabled, 1, sizeof(int),f);
+      cheatsList[i].enabled = cheatsList[i].enabled ? true : false;
+      fread(&cheatsList[i].address, 1, sizeof(u32),f);
+      cheatsList[i].rawaddress = cheatsList[i].address;
+      fread(&cheatsList[i].value, 1, sizeof(u32),f);
+      fread(&cheatsList[i].oldValue, 1, sizeof(u32),f);
+      fread(&cheatsList[i].codestring, 1, 20*sizeof(char),f);
+      if(fread(&cheatsList[i].desc, 1, 32*sizeof(char),f) != 32*sizeof(char)) {
+        fclose(f);
+        return false;
+      }
+    }
   }
 
   bool firstCodeBreaker = true;
@@ -1615,59 +2815,80 @@
   return true;
 }
 
-extern int *extCpuLoopTicks;
-extern int *extClockTicks;
-extern int *extTicks;
-extern int cpuSavedTicks;
-
-extern void debuggerBreakOnWrite(u32 *, u32, u32, int); 
-
-#define CPU_BREAK_LOOP \
-  cpuSavedTicks = cpuSavedTicks - *extCpuLoopTicks;\
-  *extCpuLoopTicks = *extClockTicks;\
-  *extTicks = *extClockTicks;
+extern int cpuNextEvent;
+
+extern void debuggerBreakOnWrite(u32 , u32, u32, int, int); 
+
+static u8 cheatsGetType(u32 address)
+{
+  switch(address >> 24) {
+  case 2:
+    return freezeWorkRAM[address & 0x3FFFF];
+  case 3:
+    return freezeInternalRAM[address & 0x7FFF];
+  case 5:
+    return freezePRAM[address & 0x3FC];
+  case 6:
+    if (address > 0x06010000)
+      return freezeVRAM[address & 0x17FFF];
+    else
+      return freezeVRAM[address & 0x1FFFF];
+  case 7:
+    return freezeOAM[address & 0x3FC];
+  }
+  return 0;
+}
 
-void cheatsWriteMemory(u32 *address, u32 value, u32 mask)
+void cheatsWriteMemory(u32 address, u32 value)
 {
 #ifdef BKPT_SUPPORT
 #ifdef SDL
   if(cheatsNumber == 0) {
-    debuggerBreakOnWrite(address, *address, value, 2);
-    CPU_BREAK_LOOP;
-    *address = value;
-    return;
+    int type = cheatsGetType(address);
+    u32 oldValue = debuggerReadMemory(address);
+    if(type == 1 || (type == 2 && oldValue != value)) {
+      debuggerBreakOnWrite(address, oldValue, value, 2, type);
+      cpuNextEvent = 0;
+    }
+    debuggerWriteMemory(address, value);
   }
 #endif
 #endif
 }
 
-void cheatsWriteHalfWord(u16 *address, u16 value, u16 mask)
+void cheatsWriteHalfWord(u32 address, u16 value)
 {
 #ifdef BKPT_SUPPORT
 #ifdef SDL
   if(cheatsNumber == 0) {
-    debuggerBreakOnWrite((u32 *)address, *address, value, 1);
-    CPU_BREAK_LOOP;
-    *address = value;
-    return;
+    int type = cheatsGetType(address);
+    u16 oldValue = debuggerReadHalfWord(address);
+    if(type == 1 || (type == 2 && oldValue != value)) {
+      debuggerBreakOnWrite(address, oldValue, value, 1, type);
+      cpuNextEvent = 0;
+    }
+    debuggerWriteHalfWord(address, value);
   }
 #endif
 #endif
 }
 
 #if defined BKPT_SUPPORT && defined SDL
-void cheatsWriteByte(u8 *address, u8 value)
+void cheatsWriteByte(u32 address, u8 value)
 #else
-void cheatsWriteByte(u8 *, u8)
+void cheatsWriteByte(u32, u8)
 #endif
 {
 #ifdef BKPT_SUPPORT
 #ifdef SDL
   if(cheatsNumber == 0) {
-    debuggerBreakOnWrite((u32 *)address, *address, value, 0);
-    CPU_BREAK_LOOP;
-    *address = value;
-    return;
+    int type = cheatsGetType(address);
+    u8 oldValue = debuggerReadByte(address);
+    if(type == 1 || (type == 2 && oldValue != value)) {
+      debuggerBreakOnWrite(address, oldValue, value, 0, type);
+      cpuNextEvent = 0;
+    }
+    debuggerWriteByte(address, value);
   }
 #endif
 #endif
